function BM_Rec_Level_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("UNIT_NAME_UPDATE");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("MINIMAP_ZONE_CHANGED");
	this:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	this:RegisterEvent("PLAYER_LEVEL_UP");

end

function BM_Rec_Level_OnEvent()
	
	if (event == "VARIABLES_LOADED") then			
		BRL_initialize();
	end

	if (event == "MINIMAP_ZONE_CHANGED" or event == "ZONE_CHANGED_NEW_AREA" or 
			event == "PLAYER_ENTERING_WORLD" or event == "PLAYER_LEVEL_UP") then
		BM_Rec_Level_Update_Text();
	end

end

function BRL_initialize()
	-- double check that we are getting the player's name update
	if (BRL_STARTUP.m_Loaded == false) then
		-- add the realm to the "player's name" for the config settings
		BRL_STARTUP.m_strPlayer = GetCVar("realmName") .. "|" .. UnitName("player");
		
		-- Make sure BM_CONFIG is ready
		if (not BRL_CONFIG) then
			BRL_CONFIG = { };
		end

		if (not BRL_CONFIG[BRL_STARTUP.m_strPlayer]) then
			BRL_CONFIG[BRL_STARTUP.m_strPlayer] = { };
		end
		
		-- Zone Info Box Show/Hide
		if (BRL_CONFIG[BRL_STARTUP.m_strPlayer].zone_info_enable == nil) then
			BRL_CONFIG[BRL_STARTUP.m_strPlayer].zone_info_enable = DEFAULT_BRL_ZONE_INFO_ENABLE;
		end
		-- Tooltip Show/Hide
		if (BRL_CONFIG[BRL_STARTUP.m_strPlayer].tooltip_enable == nil) then
			BRL_CONFIG[BRL_STARTUP.m_strPlayer].tooltip_enable = DEFAULT_BRL_TOOLTIP_ENABLE;
		end
		-- Map Text Show/Hide
		if (BRL_CONFIG[BRL_STARTUP.m_strPlayer].map_text_enable == nil) then
			BRL_CONFIG[BRL_STARTUP.m_strPlayer].map_text_enable = DEFAULT_BRL_MAP_TEXT_ENABLE;
		end
		-- Tooltip Offset Left/Right
		if (BRL_CONFIG[BRL_STARTUP.m_strPlayer].tooltip_offset_left == nil) then
			BRL_CONFIG[BRL_STARTUP.m_strPlayer].tooltip_offset_left = DEFAULT_BRL_TOOLTIP_OFFSET_LEFT;
		end
		-- Tooltip Offset Bottom/Top
		if (BRL_CONFIG[BRL_STARTUP.m_strPlayer].tooltip_offset_bottom == nil) then
			BRL_CONFIG[BRL_STARTUP.m_strPlayer].tooltip_offset_bottom = DEFAULT_BRL_TOOLTIP_OFFSET_BOTTOM;
		end
		if (BRL_CONFIG[BRL_STARTUP.m_strPlayer].border_alpha == nil) then
			BRL_CONFIG[BRL_STARTUP.m_strPlayer].border_alpha = DEFAULT_BRL_BORDER_ALPHASLIDER;
		end
			
		if (BRL_CONFIG[BRL_STARTUP.m_strPlayer].zone_info_enable == false) then
			BM_Rec_Level:Hide();
			BM_Rec_Level_Text_Frame:Hide();
		else
			BM_Rec_Level:Show();
			BM_Rec_Level_Text_Frame:Show();
		end
		if (BRL_CONFIG[BRL_STARTUP.m_strPlayer].map_text_enable == false) then
			BM_Rec_WorldMap_Frame:Hide();
		else
			BM_Rec_WorldMap_Frame:Show();
		end
		
		if (BRL_CONFIG[BRL_STARTUP.m_strPlayer].tooltip_offset_bottom == false) then
			BRL_SET_BOTTOM_TOP = "TOP";
		else
			BRL_SET_BOTTOM_TOP = "BOTTOM";
		end
		
		if (BRL_CONFIG[BRL_STARTUP.m_strPlayer].tooltip_offset_left == false) then
			BRL_SET_LEFT_RIGHT = "RIGHT";
		else
			BRL_SET_LEFT_RIGHT = "LEFT";
		end

		BM_Rec_Level:SetAlpha(BRL_CONFIG[BRL_STARTUP.m_strPlayer].border_alpha);
		
		if ( BRL_CONFIG[BRL_STARTUP.m_strPlayer].show_tooltip_faction == nil ) then
			BRL_CONFIG[BRL_STARTUP.m_strPlayer].show_tooltip_faction = DEFAULT_BRL_SHOW_TOOLTIP_FACTION;
		end
		
		if ( BRL_CONFIG[BRL_STARTUP.m_strPlayer].show_tooltip_instance == nil ) then
			BRL_CONFIG[BRL_STARTUP.m_strPlayer].show_tooltip_instance = DEFAULT_BRL_SHOW_TOOLTIP_INSTANCE;
		end

		

		-- variables are loaded, ready to go
		BRL_STARTUP.m_Loaded = true;
		

		if (DEFAULT_CHAT_FRAME) then
			DEFAULT_CHAT_FRAME:AddMessage(BMRECLEVEL_LOADED .. BRL_LOADED_INFO);
    else
			UIErrorsFrame:AddMessage(BMRECLEVEL_LOADED, 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
		end
	end
end

function BM_Rec_Level_Update_Text()	
  local player_level = UnitLevel("player");
  BM_REC_LEVEL_BUTTON_TEXT = "";
	for i = 0, table.getn(BM_RECOMMEND), 1 do
		if (string.find(BM_RECOMMEND[i].zone, GetZoneText())) then
			BM_Rec_Level_Update_Tooltip_Text(i);
			if (BM_RECOMMEND[i].player_faction ~= BRL_CITY) then
				if (player_level <= (BM_RECOMMEND[i].low_level-4)) then
				BM_REC_LEVEL_BUTTON_TEXT = format(RECOMMEND_TEXT_RED, BM_RECOMMEND[i].low_level, BM_RECOMMEND[i].high_level);
				elseif (player_level < BM_RECOMMEND[i].low_level and player_level >= (BM_RECOMMEND[i].low_level-3)) then
					BM_REC_LEVEL_BUTTON_TEXT = format(RECOMMEND_TEXT_YELLOW, BM_RECOMMEND[i].low_level, BM_RECOMMEND[i].high_level);
				elseif (player_level >= BM_RECOMMEND[i].low_level and player_level <= (BM_RECOMMEND[i].high_level)) then
					BM_REC_LEVEL_BUTTON_TEXT = format(RECOMMEND_TEXT_GREEN, BM_RECOMMEND[i].low_level, BM_RECOMMEND[i].high_level);
				else
					BM_REC_LEVEL_BUTTON_TEXT = format(RECOMMEND_TEXT_GRAY, BM_RECOMMEND[i].low_level, BM_RECOMMEND[i].high_level);
				end
			else
				BM_REC_LEVEL_BUTTON_TEXT = format(RECOMMEND_TEXT_WHITE, BM_RECOMMEND[i].player_faction);
			end
			
		end
	end
	BM_Rec_Level_Text:SetText(BRL_ZONE_RANGE .. BM_REC_LEVEL_BUTTON_TEXT);
	return 
end

function  BM_Rec_Level_Update_Tooltip_Text(BM_TEMP)	
  local player_level = UnitLevel("player");
	BM_REC_LEVEL_TOOLTIP_TEXT = ""..
				BRL_TOOLTIP_CZONE .. BM_WHITE .. GetZoneText() .. BM_FONT_OFF .. "\n";

  if ( (BM_RECOMMEND[BM_TEMP].instances ~= BRL_NONE) and (BRL_CONFIG[BRL_STARTUP.m_strPlayer].show_tooltip_instance) ) then
		BM_REC_LEVEL_TOOLTIP_TEXT = BM_REC_LEVEL_TOOLTIP_TEXT ..			
				BRL_TOOLTIP_CINSTANCES .. BM_WHITE .. BM_RECOMMEND[BM_TEMP].instances .. "\n" .. BM_FONT_OFF;
	end			

	BM_REC_LEVEL_TOOLTIP_TEXT = BM_REC_LEVEL_TOOLTIP_TEXT ..			
				"\n" .. BM_WHITE .. BRL_TOOLTIP_RECOMMEND .. "\n" .. BM_FONT_OFF;

	for i = 0, table.getn(BM_RECOMMEND), 1 do
		if ( BM_RECOMMEND[i].high_level - player_level <= BM_RECOMMEND[i].range_level and 
		     BM_RECOMMEND[i].high_level - player_level >= 0 ) then	
			if (UnitFactionGroup("player") == BM_RECOMMEND[i].player_faction or BM_RECOMMEND[i].player_faction == BRL_CONTESTED) then

				-- Add zone name and level range.
			  BM_TEMP_TEXT = 
									BRL_TOOLTIP_RZONE .. BM_WHITE .. BM_RECOMMEND[i].zone .. "\n" .. BM_FONT_OFF ..
									BRL_TOOLTIP_RRANGE .. BM_WHITE .. "(" .. BM_RECOMMEND[i].low_level .. "-" .. BM_RECOMMEND[i].high_level .. ")" .. "\n" .. BM_FONT_OFF;
        -- Show faction
				if ( BRL_CONFIG[BRL_STARTUP.m_strPlayer].show_tooltip_faction ) then
					BM_TEMP_TEXT = BM_TEMP_TEXT .. BRL_TOOLTIP_RFACTION .. BM_WHITE .. BM_RECOMMEND[i].player_faction .. "\n" .. BM_FONT_OFF;
				end
				-- add any instances
				if ( (BM_RECOMMEND[i].instances ~= BRL_NONE) and (BRL_CONFIG[BRL_STARTUP.m_strPlayer].show_tooltip_instance) ) then
					BM_TEMP_TEXT = BM_TEMP_TEXT .. BRL_TOOLTIP_RINSTANCES .. BM_WHITE .. BM_RECOMMEND[i].instances .. "\n" .. BM_FONT_OFF;
        end
				BM_TEMP_TEXT = BM_TEMP_TEXT .. "\n";

				BM_REC_LEVEL_TOOLTIP_TEXT = BM_REC_LEVEL_TOOLTIP_TEXT .. BM_TEMP_TEXT;

			end
		end
	end
	return
end

-- when the mouse goes over the main frame, this gets called
function BM_Rec_Level_OnEnter()
	BRL_STARTUP.m_strPlayer = GetCVar("realmName") .. "|" .. UnitName("player");
	if (BRL_CONFIG[BRL_STARTUP.m_strPlayer].tooltip_enable) then
		if (BRL_CONFIG[BRL_STARTUP.m_strPlayer].tooltip_enable == true) then
			if (BRL_SET_BOTTOM_TOP == "BOTTOM") then
				GameTooltip:SetOwner(this, "ANCHOR_NONE");
				GameTooltip:SetPoint("TOP" .. BRL_SET_LEFT_RIGHT, "BM_Rec_Level", "BOTTOM" .. BRL_SET_LEFT_RIGHT, 0, 0);
				-- set the tool tip text
				GameTooltip:SetText(BRL_TOOPTIP_TITLE,nil,nil,nil,1);
				GameTooltip:AddLine(BM_REC_LEVEL_TOOLTIP_TEXT);
				GameTooltip:Show();
			elseif (BRL_SET_BOTTOM_TOP == "TOP") then
				GameTooltip:SetOwner(this, "ANCHOR_NONE");
				GameTooltip:SetPoint("BOTTOM" .. BRL_SET_LEFT_RIGHT, "BM_Rec_Level", "TOP" .. BRL_SET_LEFT_RIGHT, 0, 0);
				-- set the tool tip text
				GameTooltip:SetText(BRL_TOOPTIP_TITLE,nil,nil,nil,1);
				GameTooltip:AddLine(BM_REC_LEVEL_TOOLTIP_TEXT);
				GameTooltip:Show();
			end
			
		end
	end
end

function BM_Rec_Level_OnLeave()
	BRL_STARTUP.m_strPlayer = GetCVar("realmName") .. "|" .. UnitName("player");
	if (BRL_CONFIG[BRL_STARTUP.m_strPlayer].tooltip_enable == true) then
		-- put the tool tip in the default position
		GameTooltip_SetDefaultAnchor(GameTooltip, UIParent);
		GameTooltip:Hide();
	end
end

function BM_WorldMapButton_OnUpdate()
   local player_level = UnitLevel("player");
	 if (WorldMapFrame.areaName ~= nil) then 	
		 for i = 0, table.getn(BM_RECOMMEND), 1 do
			if (string.find(BM_RECOMMEND[i].zone, WorldMapFrame.areaName)) then
				if (player_level <= (BM_RECOMMEND[i].low_level-4)) then
					BM_Rec_WorldMap_Text:SetText(format(REC_WORLDMAP_TEXT_RED, BM_RECOMMEND[i].low_level, BM_RECOMMEND[i].high_level, BM_RECOMMEND[i].instances));
				elseif (player_level < BM_RECOMMEND[i].low_level and player_level >= (BM_RECOMMEND[i].low_level-3)) then
					BM_Rec_WorldMap_Text:SetText(format(REC_WORLDMAP_TEXT_YELLOW, BM_RECOMMEND[i].low_level, BM_RECOMMEND[i].high_level, BM_RECOMMEND[i].instances));
				elseif (player_level >= BM_RECOMMEND[i].low_level and player_level <= (BM_RECOMMEND[i].high_level)) then
					BM_Rec_WorldMap_Text:SetText(format(REC_WORLDMAP_TEXT_GREEN, BM_RECOMMEND[i].low_level, BM_RECOMMEND[i].high_level, BM_RECOMMEND[i].instances));
				else
					BM_Rec_WorldMap_Text:SetText(format(REC_WORLDMAP_TEXT_GRAY, BM_RECOMMEND[i].low_level, BM_RECOMMEND[i].high_level, BM_RECOMMEND[i].instances));
				end
			end
		end
	else
		BM_Rec_WorldMap_Text:SetText("");
	end

	if (WorldMapFrame.poiHighlight == 1) then
		for i = 0, table.getn(BM_RECOMMEND), 1 do
			if (string.find(BM_RECOMMEND[i].zone, WorldMapFrameAreaLabel:GetText())) then
				BM_Rec_WorldMap_Text:SetText(format(REC_WORLDMAP_TEXT, BM_RECOMMEND[i].player_faction, BM_RECOMMEND[i].instances));
			end
		end
	end
end

function BRL_Zone_Info_Enable(msg)
	if (msg == false) then
		BRL_CONFIG[BRL_STARTUP.m_strPlayer].zone_info_enable = false;
		BM_Rec_Level:Hide();
		BM_Rec_Level_Text_Frame:Hide();
	else
		BRL_CONFIG[BRL_STARTUP.m_strPlayer].zone_info_enable = true;
		BM_Rec_Level:Show();
		BM_Rec_Level_Text_Frame:Show();
	end	
end

function BRL_Tooltip_Enable(msg)
	if (msg == false) then
		BRL_CONFIG[BRL_STARTUP.m_strPlayer].tooltip_enable = false;
	else
		BRL_CONFIG[BRL_STARTUP.m_strPlayer].tooltip_enable = true;
	end	
end

function BRL_Map_Text_Enable(msg)
	if (msg == false) then
		BRL_CONFIG[BRL_STARTUP.m_strPlayer].map_text_enable = false;
		BM_Rec_WorldMap_Frame:Hide();
	else
		BRL_CONFIG[BRL_STARTUP.m_strPlayer].map_text_enable = true;
		BM_Rec_WorldMap_Frame:Show();
	end	
end

function BRL_Tooltip_Offset_Left(msg)
	if (msg == false) then
		BRL_CONFIG[BRL_STARTUP.m_strPlayer].tooltip_offset_left = false;
		BRL_SET_LEFT_RIGHT = "RIGHT";
	else
		BRL_CONFIG[BRL_STARTUP.m_strPlayer].tooltip_offset_left = true;
		BRL_SET_LEFT_RIGHT = "LEFT";
	end	
end

function BRL_Tooltip_Offset_Bottom(msg)
	if (msg == false) then
		BRL_CONFIG[BRL_STARTUP.m_strPlayer].tooltip_offset_bottom = false;
		BRL_SET_BOTTOM_TOP = "TOP";
	else
		BRL_CONFIG[BRL_STARTUP.m_strPlayer].tooltip_offset_bottom = true;
		BRL_SET_BOTTOM_TOP = "BOTTOM";
	end	
end

function BRL_Show_Tooltip_Faction(msg)
	if (msg == false) then
		BRL_CONFIG[BRL_STARTUP.m_strPlayer].show_tooltip_faction = false;
	else
		BRL_CONFIG[BRL_STARTUP.m_strPlayer].show_tooltip_faction = true;
	end	
	BM_Rec_Level_Update_Text();
end

function BRL_Show_Tooltip_Instance(msg)
	if (msg == false) then
		BRL_CONFIG[BRL_STARTUP.m_strPlayer].show_tooltip_instance = false;
	else
		BRL_CONFIG[BRL_STARTUP.m_strPlayer].show_tooltip_instance = true;
	end	
	BM_Rec_Level_Update_Text();
end
	
function BRL_Border_Alpha(msg)
	if (msg < 0 or msg > 1) then
		UIErrorsFrame:AddMessage(BRL_ERROR_MESSAGE_1, 1.0, 0.0, 0.0, 1.0, UIERRORS_HOLD_TIME);
	else
		BRL_CONFIG[BRL_STARTUP.m_strPlayer].border_alpha = msg;
		BM_Rec_Level:SetAlpha(BRL_CONFIG[BRL_STARTUP.m_strPlayer].border_alpha);
	end
end

function  BRL_Reset_SlashHandler()
	StaticPopup_Show("BRL_RESET_ALL");
end

function BRL_Reset_Everything()
	BRL_CONFIG[BRL_STARTUP.m_strPlayer].zone_info_enable = DEFAULT_BRL_ZONE_INFO_ENABLE;
	BRL_CONFIG[BRL_STARTUP.m_strPlayer].tooltip_enable = DEFAULT_BRL_TOOLTIP_ENABLE;
	BRL_CONFIG[BRL_STARTUP.m_strPlayer].map_text_enable = DEFAULT_BRL_MAP_TEXT_ENABLE;
	BRL_CONFIG[BRL_STARTUP.m_strPlayer].tooltip_offset_left = DEFAULT_BRL_TOOLTIP_OFFSET_LEFT;
	BRL_CONFIG[BRL_STARTUP.m_strPlayer].tooltip_offset_bottom = DEFAULT_BRL_TOOLTIP_OFFSET_BOTTOM;
	BRL_CONFIG[BRL_STARTUP.m_strPlayer].show_tooltip_faction = DEFAULT_BRL_SHOW_TOOLTIP_FACTION;
	BRL_CONFIG[BRL_STARTUP.m_strPlayer].show_tooltip_instance = DEFAULT_BRL_SHOW_TOOLTIP_INSTANCE;
	BRL_CONFIG[BRL_STARTUP.m_strPlayer].border_alpha = DEFAULT_BRL_BORDER_ALPHASLIDER;
	BM_Rec_Level:ClearAllPoints();
	BM_Rec_Level:SetPoint("CENTER", "UIParent", "CENTER", 0, 0);
	BM_Rec_Level:Show();
	BM_Rec_Level_Text_Frame:Show();
	BRL_SET_BOTTOM_TOP = "BOTTOM";
	BRL_SET_LEFT_RIGHT = "LEFT";
end