TITAN_BRL_ID =  "BRL";


function TitanPanelBRLButton_OnLoad()
	this.registry = { 
		id = TITAN_BRL_ID,
		menuText = TITAN_BRL_MENU_TEXT, 
		buttonTextFunction = "TitanPanelBRLButton_GetButtonText", 
		tooltipTitle = TITAN_BRL_TOOLTIP_TITEL,
		tooltipTextFunction = "TitanPanelBRLButton_GetTooltipText", 
		savedVariables = {
			ShowLabelText = 1,  -- Default to 1
		}
	};
	
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("MINIMAP_ZONE_CHANGED");
	this:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	this:RegisterEvent("PLAYER_LEVEL_UP");
end

function TitanPanelBRLButton_OnEvent()
	TitanPanelButton_UpdateButton(TITAN_BRL_ID);
end

function TitanPanelBRLButton_GetButtonText(id)
	return TITAN_BRL_BUTTON_LABEL, BM_REC_LEVEL_BUTTON_TEXT;
end

function TitanPanelBRLButton_GetTooltipText()
	return BM_REC_LEVEL_TOOLTIP_TEXT;	
end

function TitanPanelRightClickMenu_PrepareBRLMenu()
	local info;
	local realmplayer = GetCVar("realmName") .. "|" .. UnitName("player");

	TitanPanelRightClickMenu_AddTitle(TitanPlugins[TITAN_BRL_ID].menuText);	

	info = {};
	info.text = TITAN_BRL_TOGGLE_FACTION;
	info.func = TitanPanelBRLButton_ToggleFaction;
	info.checked = BRL_CONFIG[realmplayer].show_tooltip_faction;
	UIDropDownMenu_AddButton(info); 
	
	info = {};
	info.text = TITAN_BRL_TOGGLE_INSTANCE;
	info.func = TitanPanelBRLButton_ToggleInstance;
	info.checked = BRL_CONFIG[realmplayer].show_tooltip_instance;
	UIDropDownMenu_AddButton(info); 	
	
	info = {};
	info.text = TITAN_BRL_TOGGLE_MAP_TEXT;
	info.func = TitanPanelBRLButton_ToggleMapText;
	info.checked = BRL_CONFIG[realmplayer].map_text_enable;
	UIDropDownMenu_AddButton(info); 

	TitanPanelRightClickMenu_AddSpacer();
	TitanPanelRightClickMenu_AddToggleLabelText(TITAN_BRL_ID);
	TitanPanelRightClickMenu_AddCommand(TITAN_PANEL_MENU_HIDE, TITAN_BRL_ID, TITAN_PANEL_MENU_FUNC_HIDE);
end

function TitanPanelBRLButton_ToggleInstance()
	local realmplayer = GetCVar("realmName") .. "|" .. UnitName("player");
	BRL_Show_Tooltip_Instance(not BRL_CONFIG[realmplayer].show_tooltip_instance);
end

function TitanPanelBRLButton_ToggleFaction()
	local realmplayer = GetCVar("realmName") .. "|" .. UnitName("player");
	BRL_Show_Tooltip_Faction(not BRL_CONFIG[realmplayer].show_tooltip_faction);
end

function TitanPanelBRLButton_ToggleMapText()
	local realmplayer = GetCVar("realmName") .. "|" .. UnitName("player");
	BRL_Map_Text_Enable(not BRL_CONFIG[realmplayer].map_text_enable);
end
